//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// AgentBoundingBox.h: interface for the AgentBoundingBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AGENTBOUNDINGBOX_H__D5E61EF1_63A7_11D4_9FAF_0000E87A7A07__INCLUDED_)
#define AFX_AGENTBOUNDINGBOX_H__D5E61EF1_63A7_11D4_9FAF_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Agent.h"
#include "AnalysisBoundingBox.h"

const double BB_CENTER = 50;
const double BB_SIDE = 20;

const int BB_XWEIGHT = 50;
const int BB_YWEIGHT = 50;
const int BB_ZWEIGHT = 50;

class AgentBoundingBox  : public Agent
{
public:
	AgentBoundingBox(int zoneType = 0);
	virtual ~AgentBoundingBox();

	virtual bool		perZoneType() {return true;};	// This agent type is separated by Zone Type
	virtual bool		hasInterface() {return true;};	// This agent type has an interface
	virtual	int			startingDeployment() {return 1;};	// How many of these to deploy initially
	virtual int			startingWeight() {return 50;};		// What is the starting weight of this agent type?
	virtual bool		step(int stepNum);
	virtual string		getLocalType();	// Returns the name of the Agent Type
	virtual Agent*		newOne(int zoneType = 0);
	virtual void		copyProperties(Agent* original);
	virtual void		doInterface();
	virtual void		reportSettings();		// Add settings to Settings		NOTE: Agents are not Settables!
	virtual void		receiveSettings();		// Get settings from Settings		NOTE: Agents are not Settables!

protected:

	virtual void		loadAnalyses();

	double				_centerX;
	double				_centerY;
	double				_centerZ;
	double				_sideX;
	double				_sideY;
	double				_sideZ;

	int					_XWeight;
	int					_YWeight;
	int					_ZWeight;

	AnalysisBoundingBox* boundingAnalysis;
};

#endif // !defined(AFX_AGENTBOUNDINGBOX_H__D5E61EF1_63A7_11D4_9FAF_0000E87A7A07__INCLUDED_)
