//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// AgentControl.h: interface for the AgentControl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AGENTCONTROL_H__44214123_3A7D_11D4_9F88_0000E87A7A07__INCLUDED_)
#define AFX_AGENTCONTROL_H__44214123_3A7D_11D4_9F88_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Design.h"
#include "Agent.h"
#include <list>
#include <string>
#include "MessageContentTypes.h"

using namespace std;

class AgentControl  
{
public:
	int getTotalAgentTypes();
	double getImpression(bool &valid, int ZoneType, AgentType* agent);
	AgentControl(Design* startingDesign = NULL);
	virtual ~AgentControl();

	static double evaluate(Design* theDesign);

	void		dispatchMessage(Message* theMessage);

	static			Agent*	getAgent(AgentID ID);
	static	void	newAgent(Agent*	theAgent);			// This is called automatically by Agent's constuctor
	static	void	removeAgent(Agent*	theAgent);		// This is called automatically by Agent's destructor
	static	Design*			getCurrentDesign();

	static void		relay(Message* theMessage);

	void	getAgentTypes(int zoneType, list<AgentType*>& typeList);

	static  AgentControl*	theAgentControl;

	void    removeZoneType(int which);
	void    addZoneType(int after);
	void    setNumZoneTypes(int newNumTypes);

private:
	static void storeImpressions(Phenotype& phenotype);

	void	instantiateAgents();
	static	list<Agent*> activeAgents;
	static	Design* currentDesign;
	static	list<Agent*> unfinishedAgents;
	static	list<AgentType*> agentTypes;
	int		step;

};

#endif // !defined(AFX_AGENTCONTROL_H__44214123_3A7D_11D4_9F88_0000E87A7A07__INCLUDED_)
