//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// AgentLocalizedBoundingBox.h: interface for the AgentLocalizedBoundingBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AGENTLOCALIZEDBOUNDINGBOX_H__49879683_EBCE_11D4_AE3D_00C04FA36E77__INCLUDED_)
#define AFX_AGENTLOCALIZEDBOUNDINGBOX_H__49879683_EBCE_11D4_AE3D_00C04FA36E77__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Agent.h"
#include "AnalysisLocalizedBoundingBox.h"
#include <vector>

using namespace std;

const int INTERSECTION_WEIGHT = 50;

class AgentLocalizedBoundingBox : public Agent
{
public:
	AgentLocalizedBoundingBox(int zoneType = 0);
	virtual ~AgentLocalizedBoundingBox();

	virtual bool		perZoneType() {return true;};	// This agent type is separated by Zone Type
	virtual bool		hasInterface() {return true;};	// This agent type has an interface
	virtual	int			startingDeployment() {return 1;};	// How many of these to deploy initially
	virtual int			startingWeight() {return 50;};		// What is the starting weight of this agent type?
	virtual bool		step(int stepNum);
	virtual string		getLocalType();	// Returns the name of the Agent Type
	virtual Agent*		newOne(int zoneType = 0);
	virtual void		copyProperties(Agent* original);
	virtual void		doInterface();
	virtual void		reportSettings();		// Add settings to Settings		NOTE: Agents are not Settables!
	virtual void		receiveSettings();		// Get settings from Settings		NOTE: Agents are not Settables!

protected:
	bool initWeightsMatrices();

	virtual void		loadAnalyses();

	vector<int>	_IntersectionWeight;
	vector<bool>	_IntersectionType;

	AnalysisLocalizedBoundingBox* localAnalysis;

};

#endif // !defined(AFX_AGENTLOCALIZEDBOUNDINGBOX_H__49879683_EBCE_11D4_AE3D_00C04FA36E77__INCLUDED_)
