//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// AgentNumShapes.h: interface for the AgentNumShapes class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AGENTNUMSHAPES_H__6BBD85D3_6943_11D4_9FBA_0000E87A7A07__INCLUDED_)
#define AFX_AGENTNUMSHAPES_H__6BBD85D3_6943_11D4_9FBA_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Agent.h"
#include "AnalysisCountShapes.h"

const int NS_DESIRED = 50;

class AgentNumShapes : public Agent  
{
public:
	AgentNumShapes(int zoneType = 0);
	virtual ~AgentNumShapes();

	virtual bool		perZoneType() {return true;};	// This agent type is separated by Zone Type
	virtual bool		hasInterface() {return true;};	// This agent type has an interface
	virtual	int			startingDeployment() {return 1;};	// How many of these to deploy initially
	virtual int			startingWeight() {return 50;};		// What is the starting weight of this agent type?
	virtual bool		step(int stepNum);
	virtual string		getLocalType() {return "AgentNumShapes";};	// Returns the name of the Agent Type
	virtual Agent*		newOne(int zoneType = 0);
	virtual void		copyProperties(Agent* original);
	virtual void		doInterface();
	virtual void		reportSettings();		// Add settings to Settings		NOTE: Agents are not Settables!
	virtual void		receiveSettings();		// Get settings from Settings		NOTE: Agents are not Settables!

private:

	virtual void		loadAnalyses();

	int					_desired;

	AnalysisCountShapes* countAnalysis;
};

#endif // !defined(AFX_AGENTNUMSHAPES_H__6BBD85D3_6943_11D4_9FBA_0000E87A7A07__INCLUDED_)
