//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// AnalysisBoundingBox.cpp: implementation of the AnalysisBoundingBox class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <maya/MGlobal.h>
#include "MFCPlugin.h"
#include "AnalysisBoundingBox.h"
#include "Design.h"
#include "AgentControl.h"
#include "Shape.h"
#include "MELUtilities.h"
#include <iostream>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AnalysisBoundingBox::AnalysisBoundingBox()
{
	name = "AnalysisBoundingBox";
}

AnalysisBoundingBox::~AnalysisBoundingBox()
{

}

void AnalysisBoundingBox::getBounds(bool& any, double& minX, double& minY, double& minZ,
											   double& maxX, double& maxY, double& maxZ,
											   int zoneType /*= -1*/)
{
	Design*	theDesign = AgentControl::getCurrentDesign();
	Phenotype*	thePhenome = &(theDesign->getPhenome());
	Shape*		currentShape;
	double tempMinX, tempMinY, tempMinZ, tempMaxX, tempMaxY, tempMaxZ;

	minX = 10000;
	minY = 10000;
	minZ = 10000;
	maxX = -10000;
	maxY = -10000;
	maxZ = -10000;

	any = false;

	for (list<Shape*>::iterator i = thePhenome->getShapes().begin(); i != thePhenome->getShapes().end(); i++) {
		if ((zoneType == -1) || (zoneType == (*i)->getPEType().getType())) {
			any = true;
			eval("float $minX = `getAttr \"" + (*i)->getLoftName() + ".bbnx\"`");
			eval("float $minY = `getAttr \"" + (*i)->getLoftName() + ".bbnz\"`");
			eval("float $minZ = `getAttr \"" + (*i)->getLoftName() + ".bbny\"`");
			eval("float $maxX = `getAttr \"" + (*i)->getLoftName() + ".bbxx\"`");
			eval("float $maxY = `getAttr \"" + (*i)->getLoftName() + ".bbxz\"`");
			eval("float $maxZ = `getAttr \"" + (*i)->getLoftName() + ".bbxy\"`");
			getMELvalue("$minX", tempMinX);
			getMELvalue("$minY", tempMinY);
			getMELvalue("$minZ", tempMinZ);
			getMELvalue("$maxX", tempMaxX);
			getMELvalue("$maxY", tempMaxY);
			getMELvalue("$maxZ", tempMaxZ);

			if (tempMinX < minX) minX = tempMinX;
			if (tempMinY < minY) minY = tempMinY;
			if (tempMinZ < minZ) minZ = tempMinZ;
			if (tempMaxX > maxX) maxX = tempMaxX;
			if (tempMaxY > maxY) maxY = tempMaxY;
			if (tempMaxZ > maxZ) maxZ = tempMaxZ;
		}
	}
}
