// AnalysisMaxHeight.cpp: implementation of the AnalysisMaxHeight class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <maya/MGlobal.h>
#include "MFCPlugin.h"
#include "AnalysisMaxHeight.h"
#include "AgentControl.h"
#include "PrimaryShape.h"
#include "Genotype.h"
#include <iostream>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AnalysisMaxHeight::AnalysisMaxHeight()
{
	name = "AnalysisMaxHeight";
}

AnalysisMaxHeight::~AnalysisMaxHeight()
{

}

double AnalysisMaxHeight::getHeight(bool& any, int zoneType) {

	Design*	theDesign = AgentControl::getCurrentDesign();
	Phenotype*	thePhenome = &(theDesign->getPhenome());
	Shape*		currentShape;
	double	maxHeight = -100000;

	any = false;

	for (list<Shape*>::iterator i = thePhenome->getShapes().begin(); i != thePhenome->getShapes().end(); i++) {
		if ((zoneType == -1) || (zoneType == (*i)->getPEType().getType())) {
			any = true;
			if ((*i)->getZHeight() + (*i)->getZStart() > maxHeight)
				maxHeight = (*i)->getZHeight() + (*i)->getZStart();
		}
	}

	return maxHeight;
}