//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
#if !defined(AFX_GENETICENGINEPROPERTIES_H__85BCF234_3657_11D4_9F85_0000E87A7A07__INCLUDED_)
#define AFX_GENETICENGINEPROPERTIES_H__85BCF234_3657_11D4_9F85_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GeneticEngine.h"

// GeneticEngineProperties.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// GeneticEngineProperties dialog

class GeneticEngineProperties : public CPropertyPage
{
	DECLARE_DYNCREATE(GeneticEngineProperties)

// Construction
public:
	GeneticEngineProperties();
	~GeneticEngineProperties();

	void refreshValues();
// Dialog Data
	//{{AFX_DATA(GeneticEngineProperties)
	enum { IDD = IDD_DIALOG1 };
	int		m_shapeParameterEdit;
	int		m_endInsertEdit;
	int		m_commandChangeEdit;
	int		m_commandDeleteEdit;
	int		m_commandInsertEdit;
	int		m_commandParametersEdit;
	int		m_copiesOfElitesEdit;
	int		m_crossoverEdit;
	int		m_elitesEdit;
	int		m_fullyRandomizeEdit;
	int		m_middleInsertEdit;
	int		m_programTypeEdit;
	int		m_shapeModeEdit;
	int		m_tournamentSizeEdit;
	int		m_wideningEdit;
	int		m_ZHeightEdit;
	int		m_ZStartEdit;
	int		m_shapeParameterSlider;
	int		m_commandChangeSlider;
	int		m_commandDeleteSlider;
	int		m_commandInsertionSlider;
	int		m_commandParametersSlider;
	int		m_crossoverSlider;
	int		m_endInsertionSlider;
	int		m_fullyRandomizeSlider;
	int		m_middleInsertionSlider;
	int		m_populationSizeEdit;
	int		m_programTypeSlider;
	int		m_shapeModeSlider;
	int		m_wideningSlider;
	int		m_ZHeightSlider;
	int		m_ZStartSlider;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(GeneticEngineProperties)
	public:
	virtual BOOL OnKillActive();
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
	public:
	void setEngine(GeneticEngine* newEngine);

protected:
	// Generated message map functions
	//{{AFX_MSG(GeneticEngineProperties)
	virtual BOOL OnInitDialog();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnChangeShapeParameterEdit();
	afx_msg void OnChangeCommandChangeEdit();
	afx_msg void OnChangeCommandDeleteEdit();
	afx_msg void OnChangeCommandInsertEdit();
	afx_msg void OnChangeCommandParametersEdit();
	afx_msg void OnChangeCrossoverEdit();
	afx_msg void OnChangeEndInsertEdit();
	afx_msg void OnChangeFullyRandomizeEdit();
	afx_msg void OnChangeMiddleInsertEdit();
	afx_msg void OnChangeProgramTypeEdit();
	afx_msg void OnChangeShapeModeEdit();
	afx_msg void OnChangeWideningEdit();
	afx_msg void OnChangeZHeightEdit();
	afx_msg void OnChangeZStartEdit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

	void recalculate(); // Recalculate dialog values after user makes a change

	GeneticEngine* theEngine;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GENETICENGINEPROPERTIES_H__85BCF234_3657_11D4_9F85_0000E87A7A07__INCLUDED_)
