//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Genotype.h: interface for the Genotype class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GENOTYPE_H__632786DE_ED45_11D3_AC39_00C04F797C24__INCLUDED_)
#define AFX_GENOTYPE_H__632786DE_ED45_11D3_AC39_00C04F797C24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include "PrimaryShape.h"

using namespace std;

class Genotype
{
public:
	Genotype();
	Genotype(const vector<MayaInfo*>& originalCurves, const std::vector<string>& layerNames);
	Genotype(const Genotype& oldGenotype);
	virtual ~Genotype();

// Accessors

	const vector<PrimaryShape*>* getShapes() const {return shapes;};

// Mutators

	void setShapes(vector<PrimaryShape*>* newShapes);
	void clearShapes();
	void mutateParam(ParamType typeOfParam);
	void mutateInsertion(InsertionType typeOfInsertion);
	void mutateDeletion();
	void mutateChange(ChangeType typeOfChange);
	void crossover(int numberOfCrossingPoints, Design* crossoverTemplate);
	void randomize(int minNumberOfStartingTransformations, int maxNumberOfStartingTransformations);

	void reduceNumZoneTypes(int newNumZoneTypes);

// Util
	const Genotype& operator=(const Genotype &oldGenotype);

private:

	vector<PrimaryShape*>* shapes;
protected:
	int getShapeToMutate();
};

#endif // !defined(AFX_GENOTYPE_H__632786DE_ED45_11D3_AC39_00C04F797C24__INCLUDED_)
