//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Opening.cpp: implementation of the Opening class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <maya/MGlobal.h>
#include "Opening.h"
#include "Random.h"
#include <iostream>
#include <sstream>
#include "PrimaryShape.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Opening::Opening()
{

}

Opening::Opening(const Opening &oldOpening) {
	start = oldOpening.getStart();
	width = oldOpening.getWidth();
}

Opening::~Opening()
{

}

string Opening::print() const {
	
	ostringstream output;
	output.precision(4);

	output << "Opening from " << start << ", width " << width;
	return output.str();
}

void Opening::mutate() {
	start = Random::genrand();
	width = Random::genrand();
}

void Opening::randomize() {
	start = Random::genrand();
	width = Random::genrand();
}

void Opening::run(PrimaryShape* theShape) {

	double stop = start + width;
	if (stop >= 1.0) stop -= 1.0;

	theShape->opening(start, stop);
}