//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Rotation.cpp: implementation of the Rotation class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <maya/MGlobal.h>
#include "Rotation.h"
#include "Random.h"
#include "Constants.h"
//#include <iostream.h>
#include "PrimaryShape.h"
#include <sstream>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// The class' statics
double Rotation::minRotation;
double Rotation::maxRotation;

Rotation::Rotation()
{

}

Rotation::Rotation(const Rotation& oldRotation) 
	: Transformation(oldRotation)
{
	rotation = oldRotation.getRotation();
}

Rotation::~Rotation()
{

}

string Rotation::print() const {
	
	ostringstream output;
	output.precision(4);

	output << "Rotate by " << rotation << " degrees";
	return output.str();
}

void Rotation::mutate() {
	rotation = Random::genrand() * (maxRotation - minRotation) + minRotation;
}

void Rotation::randomize() {
	mutate();
	randomizePERing();
}

void Rotation::run(PrimaryShape* theShape) {

	theShape->rotate(rotation);
}