//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Rotation.h: interface for the Rotation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROTATION_H__B350BBA5_E931_11D3_9F59_0000E87A7A07__INCLUDED_)
#define AFX_ROTATION_H__B350BBA5_E931_11D3_9F59_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Transformation.h"

class Rotation : public Transformation  
{
public:
	Rotation();
	Rotation(const Rotation& oldRotation);
	virtual ~Rotation();

// Accessors

	double getRotation() const {return rotation;};
	static double getMinRotation() {return minRotation;};
	static double getMaxRotation() {return maxRotation;};

// Mutators

	void setRotation(double newRot) {rotation = newRot;};
	static void setMinRotation(double newMinRotation) {minRotation = newMinRotation;};
	static void setMaxRotation(double newMaxRotation) {maxRotation = newMaxRotation;};

// Members Inherited from Command

	virtual CommandType type() const	{return COMMAND_ROTATE;};

	virtual std::string print() const;  // Output what the command is for trace purposes

	virtual Command* clone() const { return new Rotation(*this); };

	virtual void mutate(); // Mutate the parameter of the rotation

	virtual void randomize(); // Randomize parameters and PERing

	virtual void run(PrimaryShape* theShape); // Run the command
private:

	double rotation;  // Used to scale results into degrees
	static double minRotation;
	static double maxRotation;

};

#endif // !defined(AFX_ROTATION_H__B350BBA5_E931_11D3_9F59_0000E87A7A07__INCLUDED_)
