//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Scale.cpp: implementation of the Scale class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <maya/MGlobal.h>
#include "Scale.h"
#include "Random.h"
#include "Constants.h"
//#include <iostream.h>
#include "PrimaryShape.h"
#include <sstream>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// The class' statics:

double Scale::minXScale;
double Scale::maxXScale;
double Scale::minYScale;
double Scale::maxYScale;
double Scale::minZScale;
double Scale::maxZScale;

Scale::Scale()
{

}

Scale::Scale(const Scale &oldScale) 
	: Transformation(oldScale)
{
	x = oldScale.getX();
	y = oldScale.getY();
	z = oldScale.getZ();
}


Scale::~Scale()
{

}

string Scale::print() const {
	ostringstream output;
	output.precision(4);

	output << "Scale by " << x << ", " << y << ", " << z;
	return output.str();
}

void Scale::mutate() {
	x = Random::genrand() * (maxXScale - minXScale) + minXScale;
	y = Random::genrand() * (maxYScale - minYScale) + minYScale;
	z = Random::genrand() * (maxZScale - minZScale) + minZScale;
}

void Scale::randomize() {
	mutate();
	randomizePERing();
}

void Scale::run(PrimaryShape* theShape) {
	
	theShape->scale(x, y, z);
}
