//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// ShapePair.cpp: implementation of the ShapePair class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <maya/MGlobal.h>
#include "MFCPlugin.h"
#include "ShapePair.h"
#include "Shape.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ShapePair::ShapePair(const ShapePair& oldPair)
: _A(oldPair._A),
  _B(oldPair._B) 
{
}

ShapePair::~ShapePair()
{

}

bool	ShapePair::replace(Shape* oldShape, Shape* newShape)
{
	bool result = false;
	if (_A == oldShape) {
		result = true;
		_A = newShape;
	}
	if (_B == oldShape) {
		result = true;
		_B = newShape;
	}
	return result;
}

bool	ShapePair::operator==(const ShapePair &rhs)
{
	return ( ( (_A == rhs._A) && (_B == rhs._B) ) ||
		     ( (_A == rhs._B) && (_B == rhs._A) ) );
}
