//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Translation.cpp: implementation of the Translation class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <maya/MGlobal.h>
#include "Translation.h"
#include "Random.h"
#include "Constants.h"
//#include <iostream.h>
#include "PrimaryShape.h"
#include <sstream>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

double Translation::minXTranslation;
double Translation::maxXTranslation;
double Translation::minYTranslation;
double Translation::maxYTranslation;
double Translation::minZTranslation;
double Translation::maxZTranslation;

Translation::Translation()
{

}

Translation::Translation(const Translation &oldTranslation) 
	: Transformation(oldTranslation)
{
	x = oldTranslation.getX();
	y = oldTranslation.getY();
	z = oldTranslation.getZ();
}

Translation::~Translation()
{

}

string Translation::print() const {
	
	ostringstream output;
	output.precision(4);

	output << "Translate by " << x << ", " << y << ", " << z;
	return output.str();
}

void Translation::mutate() {
	x = Random::genrand() * (maxXTranslation - minXTranslation) + minXTranslation;
	y = Random::genrand() * (maxYTranslation - minYTranslation) + minYTranslation;
	z = Random::genrand() * (maxZTranslation - minZTranslation) + minZTranslation;
}

void Translation::randomize() {
	mutate();
	randomizePERing();
}

void Translation::run(PrimaryShape* theShape) {
	
	theShape->translate(x, y, z);
}