#include "stdafx.h"

#include <maya/MSimple.h>
#include <maya/MGlobal.h>
#include <maya/MString.h>
#include <maya/MDagPath.h>
#include <maya/MFnDagNode.h>
#include <maya/MSelectionList.h>
#include <maya/MItSelectionList.h>
#include <maya/MItSelectionList.h>
#include <maya/MFnTransform.h>
#include <maya/MVector.h>
#include "MyDialog.h"
#include <iostream.h>
#include "Resource.h"

DeclareSimpleCommand( scalePicked, "Alias|Wavefront", "1.0" 
);

MStatus scalePicked::doIt( const MArgList& )
{
    MDagPath            node;
    MObject             component;
    MSelectionList      list;
    MFnDagNode          nodeFn;
	MStatus				status;
	MObject				transformNode;
	double				scalings[3];

	MVector				testVector;

	AFX_MANAGE_STATE(AfxGetStaticModuleState( ));

    MGlobal::getActiveSelectionList( list );
	for ( MItSelectionList listIter( list, MFn::kNurbsSurface ); !listIter.isDone(); listIter.next() )
	{
		listIter.getDagPath( node, component );
		nodeFn.setObject( node );

		// Open up a MEL UI window to get the values
/*		MGlobal::executeCommand("window ExampleWindow1;\n\
								columnLayout;\n\
			      button -label \"Scale Them\";\n\
			      rowColumnLayout -numberOfColumns 2;\n\
				         text -label \"Name:\";\n\
				        textField;\n\
				       text -label \"City:\";\n\
				        textField;\n\
				      setParent ..;\n\
				 checkBox -label \"Lights \";\n\
					checkBox -label \"Camera \";\n\
					checkBox -label \"Action \";\n\
			showWindow ExampleWindow1;", FALSE, FALSE);

*/
		// Try scaling the objects

		
	CMyDialog	myDialog;
	if (myDialog.DoModal() == IDCANCEL) {
		cout << "Canceled." << endl;
		return MS::kSuccess;
	}


		transformNode = node.transform(&status);
		// This node has no transform - i.e., it's the world node
		if (!status && status.statusCode () == MStatus::kInvalidParameter)
        return status;
		MFnTransform  transform (transformNode, &status);
		if (!status) {
			status.perror("MFnTransform constructor");
			return status;
		}
		status = transform.getScale(scalings);
		if (!status) {
			status.perror("MFnTransformNode getScale");
			return status;
		}
		scalings[1] *= 2;
		status = transform.setScale(scalings);
		if (!status) {
			status.perror("MFnTransformNode setScale");
			return status;
		}

		printf("%s scaled\n", transform.name().asChar() );
	}

    return MS::kSuccess;
}

